<!DOCTYPE html>
<html lang="en">
<head>
  <title>task 41.10 Filter Users</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

<script>
  "use strict";
  $(document).ready(function() {
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gCOLUMN_ID = 0;
    const gCOLUMN_FIRST_NAME = 1;
    const gCOLUMN_LAST_NAME = 2;
    const gCOLUMN_COUNTRY = 3;
    const gCOLUMN_SUBJECT = 4 ;
    const gCOLUMN_REGISTERED_STATUS = 5;
    const gCOLUMN_CUSTOMER_TYPE = 6;
    const gCOLUMN_ACTION = 7;
    
    const gCOLUMN= ["id", "firstname", "lastname", "country", "subject", "registerStatus", "customerType", "action"];
    // định nghĩa table  - chưa có data
    var gUser_list=[];
    
    var gUserTable = $("#user-table").DataTable( {
      // Khai báo các cột của datatable
      "columns" : [
          { "data" : gCOLUMN[gCOLUMN_ID] },
          { "data" : gCOLUMN[gCOLUMN_FIRST_NAME]},
          { "data" : gCOLUMN[gCOLUMN_LAST_NAME] },
          { "data" : gCOLUMN[gCOLUMN_COUNTRY] },
          { "data" : gCOLUMN[gCOLUMN_SUBJECT] },
          { "data" : gCOLUMN[gCOLUMN_REGISTERED_STATUS] },
          { "data" : gCOLUMN[gCOLUMN_CUSTOMER_TYPE] },
          { "data" : gCOLUMN[gCOLUMN_ACTION] }
      ],
      // Ghi đè nội dung của cột action, chuyển thành button chi tiết
      "columnDefs": [ 
      {
          "targets": gCOLUMN_ACTION,
          "defaultContent": "<button class='info-user btn btn-info'>Chi tiết</button>"
      }]
    });
    
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    onPageLoading();

    // gán click event handler cho button chi tiet
    $("#user-table").on("click", ".info-user", function() {
      onButtonChiTietClick(this); // this là button được ấn
    });
    $("#btn-filter").on("click", function(){
      onFilterData();
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
    // infoFunction sẽ là function các nút cùng gọi
    function onButtonChiTietClick(paramChiTietButton) {
      //Xác định thẻ tr là cha của nút được chọn
      var vRowSelected = $(paramChiTietButton).parents('tr');
      //Lấy datatable row
      var vDatatableRow = gUserTable.row(vRowSelected); 
      //Lấy data của dòng 
      var vUserData = vDatatableRow.data();
      var vId = vUserData.id;
      var vFirstname = vUserData.firstname;  
      var vLastname = vUserData.lastname;    
      var vCountry = vUserData.country;    
      
      console.log(vId);
      console.log(vFirstname);
      console.log(vLastname);
      console.log(vCountry);
    }
    //khai báo hàm lọc dư liệu
    function onFilterData(){
      //B1: thu thập dữ liệu
      var vFilterObj={
        firstname:"",
        lastname:""
      };
      vFilterObj.firstname=$("#inp-firstname").val();
      vFilterObj.lastname=$("#inp-lastname").val();
      console.log(vFilterObj);//gọi thử coi dc ko
      console.log(gUser_list);//gọi thử coi list responese chay ko
      //B2: Filter dữ liệu
      var vFilterData= filterData(vFilterObj);

        //B3: Hiển thị lên table
        loadDataToTable(vFilterData);

    }
    
    
      // hàm chạy khi trang được load
    
    function onPageLoading() {
      // lấy data từ server
      $.ajax({
        url: "http://203.171.20.210:8080/devcamp-register-java-api/users",
        type: "GET",
        dataType: 'json',
        success: function(responseObject){
          //debugger;
          loadDataToTable(responseObject);
          gUser_list=responseObject;
        },
        error: function(error){
          console.assert(error.responseText);
        }
      });
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
    // load data to table
    function loadDataToTable(paramResponseObject) {
      //Xóa toàn bộ dữ liệu đang có của bảng
      gUserTable.clear();
      //Cập nhật data cho bảng 
      gUserTable.rows.add(paramResponseObject);
      //Cập nhật lại giao diện hiển thị bảng
      gUserTable.draw();
    }
    function filterData(paramFilterObj){
      var vResult=[];

      vResult=gUser_list.filter((element)=>{
        if (element.firstname.toLowerCase().includes(paramFilterObj.firstname.toLowerCase())
        &&element.lastname.toLowerCase().includes(paramFilterObj.lastname.toLowerCase())){
          return true;
        }

        });
        console.log(vResult);
      return vResult;
      
    }
  });
</script>
</head>
<body>
<div class="container">
  <h2 style="text-align: center;">Danh sách đăng ký</h2>

  <div class="row jumbotron">
    <div class="col-sm-2">
      <label class="form-label">Firstname</label>
    </div>
    <div class="col-sm-3">
      <input class="form-control" placeholder="nhập firstname..." id="inp-firstname"/>
    </div>
    <div class="col-sm-2">
      <label class="form-label">Lastname</label>
    </div>
    <div class="col-sm-3">
      <input class="form-control" placeholder="nhập lastname..." id="inp-lastname"/>
    </div>
    <div class="col-sm-2">
      <button class="btn btn-success" id="btn-filter">Tìm kiếm</button>
    </div>
  </div>
  
  <table class="table table-bordered table-striped table-hover" id="user-table">
    <thead>
      <tr>
        <th>Mã người dùng</th>
        <th>Firstname</th>
        <th>Lastname</th>
        <th>Country</th>
        <th>Subject</th>
        <th>Customer Type</th>
        <th>Register Status</th>
        <th>Action</th>
      </tr>
  </table>
</div>

</body>
</html>